
# Test basic container functionality

# SwiftScript
# int[] A;
# A[0] = 2;
# A[1] = 4;
# A[2] = -1;
# A[3] = 3;
# // Print out sum of array
# trace(sum(A));
# this is same as previous test but we force different order

package require turbine 0.0.1

proc insert_last { c i d } {
    turbine::container_immediate_insert $c $i $d
    adlb::slot_drop $c
}
proc rules { } {
    set c 1
    turbine::container_init $c integer
    adlb::slot_create $c

    turbine::integer_init 2
    turbine::store_integer 2 12345
    turbine::integer_init 3
    turbine::integer_init 4 
    turbine::store_integer 4 -1
    turbine::integer_init 5 
    # 12345 + 4 - 1 + 3 = 12351

    # set <container> <subscript> <member>
    turbine::container_immediate_insert $c "0" 2
    turbine::container_immediate_insert $c "2" 4
    turbine::container_immediate_insert $c "3" 5
    
    # initialise the result
    turbine::integer_init 6

    turbine::sum NO_STACK [ list 6 ] [ list $c ]

    # trace the result
    turbine::trace NO_STACK [ list ] [ list 6 ]
    
    # only finalise the container later make sure
    # sum handles non-finished array correctly
    turbine::c::rule 1 A "" "" "tc: insert_last $c 1 3"
    
    # wait until we assign 
    turbine::c::rule 2 A "1" "" "tc: turbine::store_integer 3 4"
    turbine::c::rule 3 A "1" "" "tc: turbine::store_integer 5 3"
}

turbine::init $env(TURBINE_ENGINES) $env(ADLB_SERVERS)
turbine::start rules
turbine::finalize

puts OK

# Help TCL free memory
proc exit args {}
